//+------------------------------------------------------------------+
//|                                                      bbhisto.mq4 |
//|                                     Copyright  2005, Nick Bilak |
//|        http://metatrader.50webs.com/         beluck[at]gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Nick Bilak"
#property link      "http://metatrader.50webs.com/"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Lime
#property indicator_color2 Aqua
#property indicator_color3 Magenta
//---- input parameters
extern int    bolingerPeriod  =13;

extern string note            = "turn on Alert = true";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

//---- buffers
double bb[];
double up[];
double lo[];
double trend[];

int i,j;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(4);
   SetIndexBuffer(0,bb); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,up); SetIndexStyle(1,DRAW_ARROW);SetIndexArrow(1,159); 
   SetIndexBuffer(2,lo); SetIndexStyle(2,DRAW_ARROW);SetIndexArrow(2,159);
   SetIndexBuffer(3,trend);
   

   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
      for(int i = limit; i >= 0; i--)
      {
      bb[i]=0;
      double d=iStdDev(NULL,0,bolingerPeriod,MODE_SMA,0,PRICE_CLOSE,i);
      if( d<0.0001) d=0.0001;
      bb[i]=((Close[i]+2*d - iMA(NULL,0,bolingerPeriod,0,MODE_SMA,PRICE_CLOSE,i)) /(4*d))*4-2;
      bb[i]=bb[i]/3;
      up[i]=EMPTY_VALUE;
      lo[i]=EMPTY_VALUE;
      trend[i] = trend[i+1];
      if (bb[i]>0) {
         up[i]=1;
         trend[i]=1;
      }
      if (bb[i]<0) {
         lo[i]=-1;
         trend[i]=-1;
      }
      
   }
   
   if (alertsOn)
         {
         if (alertsOnCurrent)
              int whichBar = 0;
         else     whichBar = 1;

         //
         //
         //
         //
         //
         
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("uptrend");
         else  doAlert("downtrend");       
   }
   
   return(0);
}
//+------------------------------------------------------------------+


void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," bollinger bands ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," bollinger bands "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}

      
   